/* 
 * CSE142, 98 Autumn
 * Homework 4
 * Rain Gods and Goddesses
 * 
 *
 * Brian-Patrick B. Billones
 * Section BD
 *
 * This program will allow you to control the weather type.  Choose from white, blue 
 * and pink snowdrops or raindrops.  You're the rain god/goddess, you decide!!
 *
 */

#include "gp142.h"
#include <stdio.h>
#include <math.h>

#include <time.h>
	/* <time.h> is here only so that one function can be called
	to seed the random number generator.
	Put it here in your program and forget about it, 
	just in case you decide later you need to use random numbers.
	*/

#define TRUE    		1
#define FALSE   		0

/* Configure the appearance of the buttons on the menu bar */
/*number of pixels of button height and width*/
#define BUTTON_HEIGHT  	35
#define BUTTON_WIDTH 	100

/*change this if you add or delete buttons*/
#define NUM_BUTTONS 	7

/*color of letter on buttons*/
#define SELECTED_COLOR   YELLOW	 
#define UNSELECTED_COLOW BLACK

#define MAX_PRECIP_EVENTS	500
	/*This is the total number of drops possible at one time.*/

/* y-ccordinate of the top of the "dirt" in the landscape*/
#define TOP_OF_DIRT (- 2 * (GP142_YMAX / 5))


/* For many of the GP142 functions, a line width of
 * zero means to fill the shape being drawn.
 */
#define FILL 0

/* Types of precipitations we support */
#define NONE 0
#define RAIN 1
#define SNOW 2

/*if you add new types of percip, you may need to change this*/
#define MAX_PRECIP_TYPES 2

/*Possible places for mouse clicks*/
#define BUTTON 1
	/*The above means you clicked on SOME button (doesn't say which one yet)*/
#define DIRT 2
	/*The above means you clicked in the dirt area */

/*******************  FUNCTION PROTOTYPES **************************/

	/*redraw all the buttons.
	The parameters tell which button should be highlighted
	*/
void DrawButtons(int current_precip, int current_color);

/*Clear all percipitation, so the landscape is just as originally*/
void ClearAllPrecipitation(int precipitation[], int precip_color[]);


/*render (draw) all the precipitation*/
void DrawAllPrecipitation(int precip_type, int bottom_x, int bottom_y, 
		 int precip_color);

void DrawLandscape();
void DrawHouse(int sun_x);

/*draw one drop*/
void DrawPrecipColumn(int precip_type, 
					  int bottom_x, 
					  int bottom_y, 
					  int precip_color);

void DrawRainDrop (int x, int y, int color);
void DrawSnowDrop (int x, int y, int color);
void DrawHailDrop (int x, int y, int color);

/*Return an integer which tells what KIND of click there was */
int  ClassifyMouseClick(int mouse_x, int mouse_y);

/*Given that a button was click, call an appropriate function to handle it*/
void handle_button(int x, int y, int *current_precip, int *current_color,
		   int *replant, int *lighten_up);

/*****************************************************************************

     MAIN

*****************************************************************************/

	/* main() has two chief purposes: to contain the important variables and 
	initialize them,
	and to contain the "event loop," which constantly looks to see if an event has
	happened, and then processes the event by calling an appropriate function.
	*/
int main(void)
{
  int quit = FALSE;
  int mouse_x, mouse_y;
  char key_hit;

  int sun_x =GP142_XMAX - 50, sun_y = GP142_YMAX - 35;

  /* 
   * The next itens tell what weather is happening, 
   its "leading edge" or bottom (how far down it is), and its color.
   As time passes, the bottom gets lower and lower.
   */
  int precipitation[MAX_PRECIP_EVENTS];		/*parallel arrays for*/ 
  int bottom_x[MAX_PRECIP_EVENTS];			/*the values of xy coor,*/
  int bottom_y[MAX_PRECIP_EVENTS];			/*color, and precipitation*/
  int precip_color[MAX_PRECIP_EVENTS];		/*type user chooses*/
  int num_drops = NONE;						/*next array element to store new*/
  int i = NONE;								/*keeps track of array element*/
 
  int current_precip = NONE, current_color = NONE; /*what to draw next */
  int precip_type = NONE;
  /*This flag will be true if all weather should be cleared*/
  int clear_flag = FALSE;
  int lighten_up = FALSE;

  /*what kind of click was there?*/
  int mouse_click;

  int event; /*the most recent GP142 event*/

  time_t t; /*needed only when initializing a random number generator*/

  /*
   * INITIALIZATIONS
   */

      
  srand (time(&t));	      /* Seed the random number generator             */
		/*This is something you should do if you plan to use random numbers.
		Put it here in your program and forget about it.
		*/

  GP142_open();           /* Open and init the GP142 Graphics Window      */
  GP142_logging(LOG_OFF); /* Change to LOG_ON if you want it.             */

  GP142_clear();	      /* This will clear the window & paint it white. */
  GP142_animate(ANI_RUN); /* Start animation so precips will grow         */

  DrawLandscape();
  DrawHouse(sun_x);
  DrawButtons(current_precip, current_color);	  /* Show the buttons...*/ 
  ClearAllPrecipitation (precipitation, precip_color);

  for (i = 0; i < MAX_PRECIP_EVENTS; i++)
  {
	  precipitation[i] = NONE;			/*initialize all arrays*/
	  bottom_x[i] = NONE;	
	  bottom_y[i] = NONE;
	  precip_color[i] = NONE;
  }


  /*
   * The main event loop:
   * --- ---- ----- -----
   * wait for the next user action, such as a mouse click or keyboard
   * keypress, or a periodic update event (allowing us to display the
   * next frame of an animation -- not used int this program)
   * and call the appropriate function to
   * handle it.  Repeat this until the user signals "quit".
   */
  while (!quit) {  /*this is the famous "event loop" */

	/*find out what has happened */
	event = GP142_await_event(&mouse_x, &mouse_y, &key_hit);

	switch (event) {
    case GP142_QUIT:
      quit = TRUE;           /* set flag to terminate loop           */
      break;

    case GP142_KBD:
		/*not needed for this program.*/
		/*Use this if user will need to hit a key.
		/*Note that scanf CANNOT be used with GP142*/
      break;

    case GP142_MOUSE:
		/* a mouse click has occurred. */
      /* check for button versus dirt */
      /* handle appropriate button click, if any */
      mouse_click = ClassifyMouseClick(mouse_x, mouse_y);
	if (mouse_click == BUTTON) {
			/* a button has been clicked.  Call a function to handle it*/
		handle_button(mouse_x, mouse_y, 
		      &current_precip, &current_color, &clear_flag, &lighten_up);
 
		if (mouse_click == clear_flag)
			ClearAllPrecipitation(precipitation, precip_color);

		if (lighten_up)
		{
			if (num_drops > 0 && num_drops <= 3)
			{
				num_drops--;
			} else if (num_drops > 3) {
				num_drops = num_drops - (rand() % (num_drops / 2));
			}
		}
		 
	} else if ((mouse_click != DIRT)
		/*it's not a button, and it's not the dirt, so it must be sky*/
		&& 
		 (current_precip != NONE) && (current_color != NONE) &&
		 (num_drops < MAX_PRECIP_EVENTS)){
		
		/*execute proper commands*/
		precipitation[num_drops] = current_precip;
		bottom_x[num_drops] = mouse_x;
		bottom_y[num_drops] = mouse_y;
		precip_color[num_drops] = current_color;

		num_drops++;	/*increment num_drops to record new values in next
						array element*/
	
	}
      
      break;

    case GP142_PERIODIC:
      	/*Some time has passed, 
		so make all the precipitation a little lower*/
		for (i = 0; 
			 i < num_drops;
			 i++)
		{
			bottom_y[i] = bottom_y[i] - rand()%10;	//vary speed of fall
			bottom_x[i] = bottom_x[i] - rand()%3 + rand()%3;	//sway drops from
																//side to side

			if(bottom_y[i] < (TOP_OF_DIRT - 10))
			{
				bottom_y[i] = GP142_YMAX;
				if ((rand() % 2) == 0)
				{
					bottom_x[i] = -(rand() % GP142_XMAX);
				} else {
					bottom_x[i] = (rand() % GP142_XMAX);
				}
				if (num_drops < MAX_PRECIP_EVENTS) {				//multiply drops
					bottom_y[num_drops] = bottom_y[i];				//when they hit the 
					precipitation[num_drops] = precipitation[i];	//ground by assigning	
					precip_color[num_drops] = precip_color[i];		//random x value
					if ((rand() % 2) == 0)
					{
						bottom_x[num_drops] = -(rand() % GP142_XMAX); //give - value
					} else {
						bottom_x[num_drops] = (rand() % GP142_XMAX);  //give + value
					}
					num_drops++;
				}
			}
		}

		/*and change the sun's position a little bit*/
		sun_x = sun_x - 2;
		if (sun_x < -GP142_XMAX -30) {
			sun_x = - sun_x;
			sun_y = sun_y -1;
				/* over a long period of time, the sun will set.*/
		}

      break;

    default:

      break;
	
    }  /*end switch */

    /* Redraw everything */
    DrawLandscape(sun_x, sun_y);
	DrawHouse(sun_x);
    DrawButtons(current_precip, current_color);
	for (i = 0; i < num_drops; i++){
		if ((precipitation[i] != NONE) && 
			(precip_color[i] != NONE)){

			DrawAllPrecipitation(precipitation[i], //draw all drops that have a
								 bottom_x[i],	   //precipitation and color	
								 bottom_y[i],	   //value other than zero
								 precip_color[i]);
		}
	}

  }  /* end event loop */

  


  /*
   * WRAP-UP
   */
  GP142_close();         /* clean up and close graphics window   */

  return 0;
}  /*end main */

/*****************************************************************************

     FUNCTIONS

*****************************************************************************/


	/*reinitialize so that ALL current precipitation is erased.
	*/
void ClearAllPrecipitation(int precipitation[], int precip_color[])
{
	int i;
	for(i = 0; i < MAX_PRECIP_EVENTS; i++)
	{
		precipitation[i] = NONE;
		precip_color[i] = NONE;
	}
}



#define RAINDROP_WIDTH 3

void DrawRainDrop (int x, int y, int color) { 
	/*draw rain drops*/
	GP142_circleXY (color, x, y, RAINDROP_WIDTH);
}

#define SNOWDROP_WIDTH 4
#define SNOWDROP_HEIGHT 5

void DrawSnowDrop (int x, int y, int color) {
	/*draw snowdrops*/
	GP142_triangleXY (color, 
					  x, y,
					  x, y + SNOWDROP_HEIGHT,
					  x + SNOWDROP_WIDTH, y,
					  FILL);
}


/*draw one drop*/
void DrawPrecipColumn(int precipitation, int bottom_x, int bottom_y, int color)
{
	if (bottom_y >= TOP_OF_DIRT - 20) {
		switch (precipitation) {
		case RAIN:
			DrawRainDrop (bottom_x, bottom_y, color);
			break;
		case SNOW:
			DrawSnowDrop (bottom_x, bottom_y, color);
			break;
		default:
			/*Bad news to ever get here.*/
			{}

		} /* end switch*/
	}
}

void DrawAllPrecipitation(int precipitation, int x, int y, int color)
{

	if (y >= TOP_OF_DIRT - 20) {
		switch (precipitation) {
		case RAIN:
			DrawRainDrop (x, y, color);
			break;
		case SNOW:
			DrawSnowDrop (x, y, color);
			break;
		default:
			/*Bad news to ever get here.*/
			{}

		} /* end switch*/
			
		}
}



int  ClassifyMouseClick(int mouse_x, int mouse_y)
{
  if ((mouse_x < -GP142_XMAX + BUTTON_WIDTH) &&
      (mouse_y < GP142_YMAX) &&
      (mouse_y > (GP142_YMAX - NUM_BUTTONS*BUTTON_HEIGHT)))
    return BUTTON;
  else if (mouse_y <= TOP_OF_DIRT)
    return DIRT;
  else
    return NONE;

}


void DrawLandscape(int sun_x, int sun_y)
{  
int text_offset = -GP142_XMAX + 15, font_size = 12;


  /* Draw the sky first */
  GP142_rectangleXY(BLUE, -GP142_XMAX, -GP142_YMAX,
		    GP142_XMAX, GP142_YMAX, FILL);
 
  /* Draw the sun */
  GP142_circleXY(YELLOW, sun_x, sun_y , 20);

  /* Draw the dirt */
  /* The dirt is a % of the height of the screen */
  GP142_rectangleXY(CYAN, -GP142_XMAX, -GP142_YMAX,
		    GP142_XMAX, TOP_OF_DIRT, FILL);
  GP142_printfXY (BLACK, text_offset, -GP142_YMAX+30, 12,
	  "Click a weather type and a color, then click on the picture.");

  
  /*Draw the mountains */

  GP142_triangleXY(MAGENTA,
				   -GP142_XMAX, TOP_OF_DIRT,
				   GP142_XMAX, TOP_OF_DIRT,
				   0, (4 * GP142_YMAX)/5 ,
				   FILL);

  if(sun_x > 0)
  {
	  GP142_triangleXY(YELLOW,
					   0, (4 * GP142_YMAX)/5,
					   40, TOP_OF_DIRT,
					   GP142_XMAX, TOP_OF_DIRT,
					   FILL);
  }else{
	  GP142_triangleXY(YELLOW,
					   0, (4 * GP142_YMAX)/5,
					   40, TOP_OF_DIRT,
					   -GP142_XMAX, TOP_OF_DIRT,
					   FILL);
  }

  GP142_triangleXY(BLACK,
		   -GP142_XMAX, TOP_OF_DIRT,
		   GP142_XMAX, TOP_OF_DIRT,
		   0, (4 * GP142_YMAX)/5 ,
		   1);

  GP142_lineXY(BLACK,
			   0, (4 * GP142_YMAX)/5,
			   40, TOP_OF_DIRT,
			   1);

  GP142_triangleXY(PURPLE,
		   -( 5 * GP142_XMAX/4), TOP_OF_DIRT,
		   (GP142_XMAX)/3  , TOP_OF_DIRT,
		   -(3* GP142_XMAX)/4, (2 * GP142_YMAX)/3 ,
		   FILL);

  if(sun_x > (-(3 * GP142_XMAX)/4))
  {
	  GP142_triangleXY(YELLOW,
					   (GP142_XMAX)/3  , TOP_OF_DIRT,
					   -(3* GP142_XMAX)/4, (2 * GP142_YMAX)/3 ,
					   -150, TOP_OF_DIRT,
					   FILL);
  }else{
	  GP142_triangleXY(YELLOW,
					   -(3* GP142_XMAX)/4, (2 * GP142_YMAX)/3,
					   -150, TOP_OF_DIRT,
					   -( 5 * GP142_XMAX/4), TOP_OF_DIRT,
					   FILL);
  }

  GP142_lineXY(BLACK,
			   -(3* GP142_XMAX)/4, (2 * GP142_YMAX)/3,
			   -150, TOP_OF_DIRT,
			   1);

  GP142_triangleXY(BLACK,
		   -( 5 * GP142_XMAX/4), TOP_OF_DIRT,
		   (GP142_XMAX)/3  , TOP_OF_DIRT,
		   -(3* GP142_XMAX)/4, (2 * GP142_YMAX)/3 ,
		   1);

  /*draw the trees*/

  GP142_rectangleXY(BROWN,						/*TREE TRUNK*/
					110, TOP_OF_DIRT, 
					140, TOP_OF_DIRT + 250,
					FILL);

  GP142_rectangleXY(BLACK,						
					110, TOP_OF_DIRT, 
					140, TOP_OF_DIRT + 250,
					1);

  GP142_triangleXY(FOREST_GREEN,
				   125, TOP_OF_DIRT + 325,
				   90, TOP_OF_DIRT + 175,
				   160, TOP_OF_DIRT + 175,
				   FILL);

  GP142_triangleXY(BLACK,
				   125, TOP_OF_DIRT + 325,
				   90, TOP_OF_DIRT + 175,
				   160, TOP_OF_DIRT + 175,
				   1);

  if( sun_x > 125 ){
	  GP142_lineXY(YELLOW,
				   125, TOP_OF_DIRT + 325,
				   160, TOP_OF_DIRT + 175,
				   2);
  }else{
	  GP142_lineXY(YELLOW,
				   125, TOP_OF_DIRT + 325,
				   90, TOP_OF_DIRT + 175,
				   2);
  }

  GP142_rectangleXY(BLACK,						
					205, TOP_OF_DIRT, 
					225, TOP_OF_DIRT + 200,
					1);

  GP142_rectangleXY(BROWN,						/*TREE TRUNK*/
					205, TOP_OF_DIRT, 
					225, TOP_OF_DIRT + 200,
					FILL);

  GP142_rectangleXY(BLACK,						
					205, TOP_OF_DIRT, 
					225, TOP_OF_DIRT + 200,
					1);

  GP142_ovalXY(BLACK,							/*TREE HOLE*/
			   210, TOP_OF_DIRT + 100,
			   220, TOP_OF_DIRT + 130,
			   FILL);

  GP142_triangleXY(FOREST_GREEN,				/*LEAVES*/
				   170, TOP_OF_DIRT + 135,
				   260, TOP_OF_DIRT + 135,
				   215, TOP_OF_DIRT + 220,
				   FILL);

  GP142_triangleXY(BLACK,
				   170, TOP_OF_DIRT + 135,
				   260, TOP_OF_DIRT + 135,
				   215, TOP_OF_DIRT + 220,
				   1);

  if( sun_x > 215 ){
	  GP142_lineXY(YELLOW,
				   215, TOP_OF_DIRT + 220,
				   260, TOP_OF_DIRT + 135,
				   2);
  }else{
	  GP142_lineXY(YELLOW,
				   215, TOP_OF_DIRT + 220,
				   170, TOP_OF_DIRT + 135,
				   2);
  }

  GP142_rectangleXY(BROWN,						/*SMALL TREE TRUNK*/
					225, TOP_OF_DIRT, 
					245, TOP_OF_DIRT + 75,
					FILL);

  GP142_rectangleXY(BLACK,						/*LEAVES*/
					225, TOP_OF_DIRT, 
					245, TOP_OF_DIRT + 75,
					1);

  GP142_triangleXY(FOREST_GREEN,
				   195, TOP_OF_DIRT + 50,
				   275, TOP_OF_DIRT + 50,
				   235, TOP_OF_DIRT + 100,
				   FILL);

  GP142_triangleXY(BLACK,
				   195, TOP_OF_DIRT + 50,
				   275, TOP_OF_DIRT + 50,
				   235, TOP_OF_DIRT + 100,
				   1);

  if( sun_x > 235 ){
	  GP142_lineXY(YELLOW,
				   235, TOP_OF_DIRT + 100,
				   275, TOP_OF_DIRT + 50,
				   2);
  }else{
	  GP142_lineXY(YELLOW,
				   235, TOP_OF_DIRT + 100,
				   195, TOP_OF_DIRT + 50,
				   2);
  } 
				    

} /*end DrawLandscape */


void DrawHouse (int sun_x)
{

  GP142_rectangleXY(PEACH,				/*BODY*/
					10, 
					TOP_OF_DIRT, 
					160, 
					TOP_OF_DIRT + 80, 
					FILL);

  GP142_rectangleXY(BLACK,				/*BODY OUTLINE*/
					10, 
					TOP_OF_DIRT, 
					160, 
					TOP_OF_DIRT + 80, 
					1);

  GP142_rectangleXY(BLACK,				/*DOOR FRAME*/
					40, 
					TOP_OF_DIRT,
					70,
					TOP_OF_DIRT + 50,
					1);

  GP142_rectangleXY(WHITE,				/*WINDOW FRAME*/
				    130,
					TOP_OF_DIRT + 50,
					100,
					TOP_OF_DIRT + 20,
					FILL);

  GP142_rectangleXY(BLACK,			
				    130,
					TOP_OF_DIRT + 50,
					100,
					TOP_OF_DIRT + 20,
					1);

  GP142_lineXY(BLACK, 
			   100,
			   TOP_OF_DIRT + 35,
			   130,
			   TOP_OF_DIRT + 35,
			   1);

  GP142_lineXY(BLACK,
			   115,
			   TOP_OF_DIRT + 50,
			   115,
			   TOP_OF_DIRT + 20,
			   1);

  GP142_circleXY(BLACK, 45, TOP_OF_DIRT + 23, 1);  /*DOOR KNOB*/

  GP142_triangleXY(BLACK,						/*ROOF*/
				   5, TOP_OF_DIRT + 80,
				   165, TOP_OF_DIRT + 80,
				   85, TOP_OF_DIRT + 140,
				   FILL);

  GP142_triangleXY(BLACK, 
				   5, TOP_OF_DIRT + 80,
				   165, TOP_OF_DIRT + 80,
				   85, TOP_OF_DIRT + 140,
				   1);

  if( sun_x > 165 ){
	  GP142_lineXY(YELLOW,
				   85, TOP_OF_DIRT + 140,
				   165, TOP_OF_DIRT + 80,
				   2);
  }else{
	  GP142_lineXY(YELLOW,
				   85, TOP_OF_DIRT + 140,
				   5, TOP_OF_DIRT + 80,
				   2);
  } 

}	/*end DrawHouse*/


/* Figure out which button was clicked */
void handle_button(int x, int y, int *current_precip, int *current_color,
		   int *clear_weather, int *lighten_up)
{
  int max_speed = 80;
  int buttonNum = 0;

  *clear_weather = FALSE; /* Assume we don't replant */

  /* If we're outside of this area, we could not have clicked on
   * a button.
   */
  if (x > -GP142_XMAX + BUTTON_WIDTH)  return;

  /* We know the mouse clicked in the column of buttons. */
  buttonNum = (GP142_YMAX - y)/BUTTON_HEIGHT;	 

  switch(buttonNum) {
  case 0:
    *current_precip = RAIN;
    break;
  case 1:
    *current_precip = SNOW;
    break;
  
  case 2:
    *current_color = WHITE;
    break;
  case 3:
    *current_color = BLUE;
    break;
  
  case 4:
	*current_color = PINK;
    break;
  
  case 5:
    *lighten_up = TRUE;
    break; 

  case 6:
    *clear_weather = TRUE;
    break; /* Signal to clear up the weather */
  default:
		/*Bad news if this is ever reached! */
		GP142_printfXY (RED, 50, 50, 14, "BAAADD NEWS!");
    break;
  }

}


/* Draws the buttons */
void DrawButtons(int current_precip, int current_color)
{
  int i, text_offset = -GP142_XMAX + 15, font_size = 12;

  /* draw rectangles for each button */
  for(i = 0; i < NUM_BUTTONS; i++) {
    GP142_rectangleXY(BLACK,
		      -GP142_XMAX + 4,
		      GP142_YMAX - i * BUTTON_HEIGHT - 2,
		      -GP142_XMAX + BUTTON_WIDTH,
		      GP142_YMAX - (i + 1)*BUTTON_HEIGHT - 2, 1);
  }

  /* display button text */
  /* "selected" buttons are highlighted (i.e., have a different color)*/
  /* This whole mess could be cleaned and put into a function
  if we could use strings. */
  i = GP142_YMAX - 25;
  if (current_precip == RAIN)
    GP142_printfXY(SELECTED_COLOR, text_offset, i, 10, "Rain");	
  else
    GP142_printfXY(BLACK, text_offset, i, 10, "Rain");	

  i -= BUTTON_HEIGHT;
  if (current_precip == SNOW)
    GP142_printfXY(SELECTED_COLOR, text_offset, i, 10, "Snow");
  else
    GP142_printfXY(BLACK, text_offset, i, 10, "Snow");

 
  /* Buttons for Colors */
  i -= BUTTON_HEIGHT;
  if (current_color == WHITE)
    GP142_printfXY(SELECTED_COLOR, text_offset, i, 10, "White");	
  else
    GP142_printfXY(BLACK, text_offset, i, 10, "White");

  i -= BUTTON_HEIGHT;
  if (current_color == BLUE)
    GP142_printfXY(SELECTED_COLOR, text_offset, i, 10, "Blue");
  else
    GP142_printfXY(BLACK, text_offset, i, 10, "Blue");

   i -= BUTTON_HEIGHT;
  if (current_color == PINK)
    GP142_printfXY(SELECTED_COLOR, text_offset, i, 10, "Pink");
  else
    GP142_printfXY(BLACK, text_offset, i, 10, "Pink");

  /* Buttons for commands */
  i -= BUTTON_HEIGHT;
  GP142_printfXY(BLACK, text_offset, i, 10, "Lighten up");

  /* This button is never "selected" */
  i -= BUTTON_HEIGHT;
  GP142_printfXY(BLACK, text_offset, i, 10, "Cease!");

}


void BadNewsMessage (void) {
	GP142_printfXY (RED, 0, 0, 16, "BAAAADDD NEWS!");
}